#!/bin/sh

# Building AbiWord requires that the JavaScript library be
# installed into abi/dist.  Only two files from there are
# needed:
#     js.h        the library's header file
#  libjs.a        the library itself
# 
# This script copies js.h into dist/PLATFORM/include and
# the library into dist/PLATFORM/lib.
# The Makefiles for AbiWord will expect to find them there.
#

OS_NAME=`uname -s | sed "s/\//-/"`
OS_RELEASE=`uname -r | sed "s/\//-/"`
OS_ARCH=`uname -m | sed -e s/i.86/i386/ -e s/sun4u/sparc64/ -e s/arm.*/arm/ -e s/sa110/arm/ | sed "s/\//-/"`

# uname -s on CygWin returns "CYGWIN32_NT"
if [ $OS_NAME = "CYGWIN32_NT" ]; then
    OS_NAME=WIN32
fi
if [ $OS_NAME = "CYGWIN32_95" ]; then
    OS_NAME=WIN32
fi

# TODO someday we need to be able to do release builds!
OBJDIR=${OS_NAME}_${OS_RELEASE}_${OS_ARCH}_DBG

DISTDIR=./dist/${OBJDIR}

if [ ! -d ./dist ]; then
    mkdir -p ./dist
fi

if [ ! -d ${DISTDIR} ]; then
    mkdir -p ${DISTDIR}
fi

if [ ! -d ${DISTDIR}/lib ]; then
    mkdir -p ${DISTDIR}/bin
fi

if [ ! -d ${DISTDIR}/lib ]; then
    mkdir -p ${DISTDIR}/lib
fi

if [ ! -d ${DISTDIR}/include ]; then
    mkdir -p ${DISTDIR}/include
fi

# the following gyrations can be simplified once autoconf works on NT
if [ $OS_NAME = "WIN32" ]; then
    # TODO we should probably put in the file test here as well, like the one in the Linux section below.
    cp ../js/src/libjs.lib ${DISTDIR}/lib/libjs_s.lib
    cp ../js/src/js.h ${DISTDIR}/include
else
    if [ -e ../js/src/.libs/libjs.a ]; then
	echo cp ../js/src/.libs/libjs.a ${DISTDIR}/lib
	cp ../js/src/.libs/libjs.a ${DISTDIR}/lib
	echo cp ../js/src/js.h ${DISTDIR}/include
	cp ../js/src/js.h ${DISTDIR}/include
###	ls -l ${DISTDIR}/lib
###	ls -l ${DISTDIR}/include
    else
	echo The JavaScript library does not appear to have been built yet.
	echo cd ../js, type configure and make
    fi
fi


