/* nspr2expat.h -- Interlude between expat and nspr to capture
**                 and isolate machine dependencies and naming
**                 conventions.
*/

#ifndef H_NSPR2EXPAT_H
#define H_NSPR2EXPAT_H

#include "prcpucfg.h"

/* Map NSRP's notion of big/little endian to EXPAT's notion of byte order. */

#ifndef BYTE_ORDER
  #ifdef IS_LITTLE_ENDIAN
    #define BYTE_ORDER 12
  #endif
  #ifdef IS_BIG_ENDIAN
    #define BYTE_ORDER 21
  #endif
  #ifndef BYTE_ORDER
    #error unknown byte order
  #endif
#endif

#endif /* H_NSPR2EXPAT_H */
